Rich Client Platform/Book
=========================

Contents
--------

*   [1 Book: Eclipse Rich Client Platform, Third Edition](#book-eclipse-rich-client-platform-third-edition)
    *   [1.1 More Information](#More-Information)
*   [2 Book: "Eclipse Rich Client Platform : Designing, Coding, and Packaging Java™ Applications, Second Edition"](#book-eclipse-rich-client-platform-designing-coding-and-packaging-java-applications-second-edition)
    *   [2.1 More Information](#More-Information-1)

Book: Eclipse Rich Client Platform, Third Edition
=================================================

This is the third edition of the RCP book based on Eclipse 4.4. 
With more than 800 pages this book has grown significantly in size and coverage. 
The exercises are extremely detailed, so that every reader should be able to follow along. 
The book covers everything you need to know about the Eclipse platform to successfully develop Eclipse 4 RCP applications. 
This book gives a detailed introduction into the Eclipse platform and covers all relevant aspects of Eclipse RCP development. 
Every topic in this book has a content section in which the topic is explained and afterwards you have several exercises to practice your learning. 
You will be guided through all relevant aspects of Eclipse 4 development using an comprehensive example which you continue to extend in the exercises. 
You will learn about the new programming concepts of Eclipse 4, e.g. the application model, dependency injection, CSS styling, the renderer framework, the event system and much more. 
Proven Eclipse technologies like SWT, JFace viewers, OSGi modularity and services, data binding, etc. are also covered in detail. 
This book requires a working knowledge of Java and assumes that you are familiar in using the Eclipse IDE for standard Java development. 
It assumes no previous experience of Eclipse plug-in and Eclipse RCP development.

Author: Lars Vogel

More Information
----------------

[Eclipse RCP book](https://www.vogella.com/books/eclipsercp.html)

Book: "Eclipse Rich Client Platform : Designing, Coding, and Packaging Java™ Applications, Second Edition"
==========================================================================================================

Authors: Jeff McAffer, Jean-Michel Lemieux, Chris Aniszczyk

Date of publication: April 15, 2010 (second edition), October 11, 2005 (first edition)

Purchase on Amazon and reviews: [Eclipse Rich Client Platform, Second Edition on Amazon.com](http://amzn.to/fK3Tky)

Publisher: Addison-Wesley Professional

In Eclipse Rich Client Platform, Second Edition, three Eclipse Rich Client Platform (RCP) project leaders show how to use Eclipse 3.5 to rapidly deliver cross-platform applications with rich, native-feel GUIs.

The authors fully reveal the power of Eclipse as a desktop application development platform; introduce important new improvements in Eclipse 3.5; and walk through developing a full-featured, branded RCP application for Windows, Linux, Mac, and other platforms—including handheld devices and kiosks.

Drawing on their extensive experience, the authors cover building, refining, and refactoring prototypes; customizing user interfaces; adding help and software management features; and building, branding, testing, and shipping finished software. They demonstrate current best practices for developing modular and dynamically extensible systems, using third-party code libraries, packaging applications for diverse environments, and much more.

For Java programmers at all levels of experience, this book

*   Introduces important new RCP features such as p2, Commands, and Databinding
*   Thoroughly covers key RCP-related technologies such as Equinox, SWT, JFace, and OSGi
*   Shows how to effectively brand and customize RCP application look-and-feel
*   Walks through user interface testing for RCP applications with SWTBot
*   Illuminates key similarities and differences between RCP and conventional plug-in development
*   Hands-on, pragmatic, and comprehensive, this book offers all the real-world, nontrivial code example working developers need—as well as "deep dives" into key technical areas that are essential to your success.

